void init_game (float *gameSpeed, byte *color) {
  char inkey, *text;
  enum {slow = 39, medium = slow + 7, fast = slow + 16} speed = fast;

  clrscrn ();
  /*
  centerHorz ("Input num of players (1 or 2, default 1)? ", CenterY - 4);
  do {
    inkey = getch ();
    if (inkey == 13) inkey = '1';
    *numOfPlayers = inkey - 48;
  } until (*numOfPlayers == 1 or *numOfPlayers == 2);
  printf ("%d", *numOfPlayers);
  
  centerHorz ("Input speed level (0 to 9, default 6)? ", CenterY - 4);
  do {
    inkey = getch ();
    if (inkey == 13) inkey = '6';
    inkey -= 48;
  } until (inkey >= 0 and inkey <= 9);
  printf ("%d", inkey);
  *gameSpeed = (10 - (float)inkey) / 100;

  centerHorz ("Increase speed with each level (Y or N, default Y)? ", CenterY - 2);
  do {
    inkey = getch ();
    if (inkey == 13) inkey = 'Y';
  } until (inkey == 'y' or inkey == 'Y' or inkey == 'n' or inkey == 'N');
  printf ("%c", inkey);
  if (inkey == 'y' or inkey == 'Y')
    *incSpeed = true;
  else
    *incSpeed = false;
  */

  centerHorz ("Select Game Speed: <slow> <medium> <fast>", CenterY - 2);
  switch (speed) {
    case slow :
      write ("<slow>", 9, slow, CenterY - 2);
      write ("<medium>", 15, medium, CenterY - 2);
      write ("<fast>", 15, fast, CenterY - 2);
      break;
    case medium :
      write ("<slow>", 15, slow, CenterY - 2);
      write ("<medium>", 9, medium, CenterY - 2);
      write ("<fast>", 15, fast, CenterY - 2);
      break;
    case fast :
      write ("<slow>", 15, slow, CenterY - 2);
      write ("<medium>", 15, medium, CenterY - 2);
      write ("<fast>", 9, fast, CenterY - 2);  
  }
  
  do {
    inkey = getch ();
    if (inkey == 0) inkey = getch ();
    
    if (inkey == lCh or inkey == '4' or inkey == 'a' or inkey == 'A') 
      switch (speed) {
        case slow : 
          speed = fast; 
          break;
        case medium : 
          speed = slow;
          break;
        case fast : 
          speed = medium;
      }

    if (inkey == rCh or inkey == '6' or inkey == 'd' or inkey == 'D') 
      switch (speed) {
        case slow : 
          speed = medium;
          break;
        case medium : 
          speed = fast; 
          break;
        case fast : 
          speed = slow;
      }
  
    switch (speed) {
      case slow :
         write ("<slow>", 9, slow, CenterY - 2);
         write ("<medium>", 15, medium, CenterY - 2);
         write ("<fast>", 15, fast, CenterY - 2);
        break;
      case medium :
        write ("<slow>", 15, slow, CenterY - 2);
        write ("<medium>", 9, medium, CenterY - 2);
        write ("<fast>", 15, fast, CenterY - 2);
        break;
      case fast :
        write ("<slow>", 15, slow, CenterY - 2);
        write ("<medium>", 15, medium, CenterY - 2);
        write ("<fast>", 9, fast, CenterY - 2);  
    }

  } until (inkey == 13);
  
  switch (speed) {
    case slow : 
      *gameSpeed = .11; 
      break;
    case medium : 
      *gameSpeed = .047;
      break;
    case fast : 
      *gameSpeed = .046;
  }
    
  text = "Select color with the arrow keys.  Color = ";
  *color = 1;
  centerHorz (text, CenterY);
  poscurs (CenterY, CenterX + strlen (text) / 2 + 1);
  writechs (block, *color, 1);
  
  do {
    do {
      inkey = getch ();
      if (inkey == 0) inkey = getch ();
    } until (inkey == lCh or inkey == rCh or inkey == uCh or inkey == dCh or inkey == 13);
    if (inkey == uCh or inkey == rCh)
      ++*color;
    else if (inkey == dCh or inkey == uCh)
      --*color;
    
    if (*color == 0) *color = 15;
    if (*color == 16) *color = 1;
    poscurs (CenterY, CenterX + strlen (text) / 2 + 1);
    writechs (block, *color, 1);
  
  } until (inkey == 13);
}

void locate (byte y, byte x) {
  poscurs (y + top, x + left);
}

void get_rnd_cords (struct scrnStruct *scrnStr, struct playerStruct *pStr, byte *x1, byte *y1) {
  do {
    *x1 = rand () % (Width - left) + 1;
    *y1 = rand () % (Height - top) + 1;
  } until (!on_scrn (scrnStr, *x1, *y1) and !on_player (pStr, *x1, *y1) and pStr->y != *y1 and pStr->x != *x1); 
}

void next_stage (struct scrnStruct *scrnStr, struct playerStruct *pStr, struct prizeStruct *przStr) {
  if (scrnStr->stage == NumOfStages) won ();
  init_scrn (scrnStr);
  init_player (pStr);
  przStr->val = 0;
  next_prize (scrnStr, pStr, przStr);
}

void won () {
  clrscrn ();
  centerHorz ("Congradulations!", CenterY - 1);
  delay (1);
  centerHorz ("You just put down on some nibbles!", CenterY + 1);
  delay (1);
  about ();
}

void centerHorz (char *text, byte yCord) {
  poscurs (yCord, CenterX - strlen (text) / 2);
  printf ("%s", text);
}

void centerVert (char *text, byte xCord) {
  poscurs (CenterY, xCord);
  printf ("%s", text);
}

void center (char *text) {
  poscurs (CenterY, CenterX - strlen (text) / 2);
  printf ("%s", text);
}

void write (char *s, int color, byte x, byte y) {
  byte i;
  
  for (i = 0; *(s + i) and *(s + i) != 10; i++) {
    poscurs (y, x + i);
    writechs (*(s + i), color, 1);
  }
}

byte good_color (byte c) {
  switch (c) {
    case 1 :
      return 12;
    case 2 :
      return 13;
    case 3 :
      return 14;
    case 7 : 
      return 10;
    case 8 : 
      return 11;
    default : 
      return c;
  }
}

void erase (byte x1, byte y1) {
  locate (y1, x1);
  printf (" ");
}

void lost (bool mute) {
  char inkey;

  clrscrn ();
  centerHorz ("You suck at nibbles, and you lost!", CenterY - 1);
  delay (1); 
  curson ();
  centerHorz ("But practice makes perfect, right (Y or N, default Y)? ", CenterY + 1);

  do {
    inkey = getch ();
    if (inkey == 13) inkey = 'Y';
  } until (inkey == 'y' or inkey == 'Y' or inkey == 'n' or inkey == 'N');
  printf ("%c\n", inkey);

  if (inkey == 'y' or inkey == 'Y') 
    main (!mute);
  else 
    about ();
}

void about () {
  clrscrn ();
  centerHorz ("Game by:  Jimmy Reumuth", CenterY - 2);
  centerHorz ("Feburary 22, 1998\n", CenterY);
  curson ();
  exit (0);
}

char lcase (char c) {
  if (c >= 65 and c <= 90) return c + 32;
  return c;
}