#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <string.h>
#include <stdlib.h>

#include "timer.c"
#include "stdinc.c"
#include "keycodes.c"

#define NumOfStages 9
#define Width 58
#define Height 19
#define ScrnWidth 80
#define ScrnHeight 25
#define CenterX (ScrnWidth / 2)
#define CenterY (ScrnHeight / 2)
#define top ((ScrnHeight - Height) / 2 - 1)
#define left ((ScrnWidth - Width) / 2 - 1)
#define path ""
#define block 219

#define lCh Left 
#define rCh Right 
#define uCh Up 
#define dCh Down 
typedef boolean bool;

struct scrnStruct {
  char scrn[Height][Width];
  char fileName[40];
  unsigned stage;
};

struct playerStruct {
  byte x, y, lives, len, oldX[9], oldY[9], i, color;
  small addx, addy;
  unsigned score;
};

struct prizeStruct {
  byte x, y, val;
};

void load_next_scrn (struct scrnStruct *scrnStr);
void init_scrn (struct scrnStruct *scrnStr);
void change_line (char *line);
void get_file_name (struct scrnStruct *scrnStr);
bool on_scrn (struct scrnStruct *scrnStr, byte x, byte y);

void init_player (struct playerStruct *pStr); 
bool on_player (struct PlayerStruct *pStr, byte x1, byte y1);
void move_player (struct playerStruct *pStr, struct scrnStruct *scrnStr);

bool next_prize (struct scrnStruct *scrnStr, struct playerStruct *pStr, struct prizeStruct *przStr);
bool on_prize (struct prizeStruct *przStr, byte x1, y1);

void init_game (float *gameSpeed, byte *color);
void locate (byte y, byte x);
void get_rnd_cords (struct scrnStruct *scrnStr, struct playerStruct *pStr, byte *x1, byte *y1);
void next_stage (struct scrnStruct *scrnStr, struct playerStruct *pStr, struct prizeStruct *przStr);
void won ();
void display_player (struct playerStruct *pStr);
void lost (bool mute);
void about ();

void erase (byte x1, byte y1);
byte good_color (byte c);
void write (char *s, int color, byte x, byte y);
void centerHorz (char *text, byte yCord);
void centerVert (char *text, byte xCord);
void center (char *text); 
char lcase (char ch);

#include "scrnNib.c"
#include "playrNib.c"
#include "prizeNib.c"
#include "functNib.c"

void main (bool mute) {
  struct scrnStruct scrnStr;
  struct playerStruct pStr;
  struct prizeStruct przStr;
  
  float gameSpeed;

  char inkey = 0; //for main loop
  
  mute = !mute;

  cursoff ();
  init_game (&gameSpeed, &pStr.color);
  srand (timer ());
  clrscrn ();
  
  scrnStr.stage = 0;

  pStr.lives = 3;
  pStr.score = 0;

  przStr.val = 0;
  
  next_stage (&scrnStr, &pStr, &przStr);
  //*****************MAIN LOOP*********************************
  do {
    if (kbhit ()) {
      inkey = lcase (getch ());
      if (inkey == 0) inkey = getch ();
        
      if (inkey == 'w' or inkey == '8' or inkey == uCh and pStr.addy != 1 ) 
        pStr.addx = 0, pStr.addy = -1;
      else if (inkey == 's' or inkey == '2' or inkey == dCh and pStr.addy != -1) 
        pStr.addx = 0, pStr.addy = 1;            
      else if (inkey == 'a' or inkey == '4' or inkey == lCh and pStr.addx != 1)   
        pStr.addx = -1, pStr.addy = 0;            
      else if (inkey == 'd' or inkey == '6' or inkey == rCh and pStr.addx != -1) 
        pStr.addx = 1, pStr.addy = 0;            
      else if (inkey == F1) {
        pStr.lives += 1;
        display_player (&pStr);
      } else if (inkey == F3 and scrnStr.stage < 9)
        next_stage (&scrnStr, &pStr, &przStr);
      else if (inkey == F2 and scrnStr.stage >= 2) {
        scrnStr.stage -= 2;
        next_stage (&scrnStr, &pStr, &przStr);
      } else if (inkey == F4)
         main (!mute);
      else if (inkey == 32) 
        if (mute)
          mute = false;
        else
          mute = true;

    } // end if (kbhit ())
    
    if (on_prize (&przStr, pStr.x, pStr.y)) {
      if (!mute) {
        sound (250 + przStr.val * 50, 2);
        sound (200 - 10 * przStr.val, 2);
        sound (300 + przStr.val * 20, 2);
      }

      pStr.len++;
      pStr.oldX[pStr.len-1] = -left -1, pStr.oldY[pStr.len-1] = -top -1;
      pStr.score += przStr.val;
      display_player (&pStr);

      if (next_prize (&scrnStr, &pStr, &przStr))
        next_stage (&scrnStr, &pStr, &przStr);
    
    } // end if (on_prize (...

    if (on_player (&pStr, pStr.x + pStr.addx, pStr.y + pStr.addy) or on_scrn (&scrnStr, pStr.x + pStr.addx, pStr.y + pStr.addy)) {
      if (!mute) {
        sound (700, 1);
        sound (500, 2);      
        sound (300, 3);      
        sound (100, 4);      
      }

      erase (przStr.x, przStr.y);      
      erase (pStr.x, pStr.y);
      for (pStr.i = 0; pStr.i < pStr.len; pStr.i++)
        erase (pStr.oldX[pStr.i], pStr.oldY[pStr.i]);
      
      pStr.lives--;
      init_player (&pStr);
      if (pStr.lives == 0) lost (mute);
      przStr.val = 0;
      next_prize (&scrnStr, &pStr, &przStr);
    }
    move_player (&pStr, &scrnStr);        
    
    delay (gameSpeed); 
  } until (inkey == 27);

  curson ();
  clrscrn ();
}

